<?php
namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Traits\TResponse;
use FM\Service\EPIsService;

class EPIsController {
    use TResponse;

    protected $EPIsService;

    public function __construct(EPIsService $EPIsService) {
        $this->EPIsService = $EPIsService;
    }
    
    public function getEPIs() {
        try {
            $data = $this->EPIsService->getEPIs();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarEPI(Request $request) {
        try {
            $params = $request->getParameters();
            $data = $this->EPIsService->salvarEPI($params["ROW"]);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirEPI(Request $request)
    {
        try {
            $data = $this->EPIsService->excluirEPI($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}