<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\FindService;
use FM\Traits\TResponse;

class FindController extends FMCrud
{
    use TResponse;
    protected $FindService;

    public function __construct($crudService, $environment, FindService $FindService)
    {
        parent::__construct($crudService, $environment);
        $this->FindService = $FindService;
    }

    public function findOperador(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperador($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findTipoSolicitacao(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoSolicitacao($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findOperadorHierarq(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperadorHierarq($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findLocal(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findLocal($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findTipoLocal(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoLocal($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findChecklist(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findChecklist($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findServico(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findServico($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findTipoMedidaSm(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoMedidaSm($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findItens(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findItens($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findEscoposServicos(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findEscoposServicos($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findAtividades(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findAtividades($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findItensChecklist(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findItensChecklist($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findClientes(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findClientes($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findPrioridades(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findPrioridades($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    

    private function getFiltro($request)
    {
        if (isset($request->getParameters()["find"])) {
            $filtro = $request->getParameters()["find"];
        } else {
            $filtro = '';
        }
        return $filtro;
    }

    public function findModeloAuditoria(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloAuditoria($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findContratosTarefas(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findContratosTarefas($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findClientesTarefas(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findClientesTarefas($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
