<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class EscoposTarefaFactory
{
    protected $connection;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
    }

    public function getEscopo()
    {
        $sql = "SELECT NRESCOPOSTAREFA, NMESCOPOSTAREFA
                FROM FCM_ESCOPOSTAREFA";
        $this->connection->executeStatement($sql);
    }

    public function escoposComAtividadeChk()
    {
        $sql = "SELECT DISTINCT FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA, FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA, FCM_ATIVIDADECHK.NRATIVIDADECHK
                FROM FCM_ESCOPOSTAREFA
                LEFT JOIN FCM_TAGSTAREFA
                  ON FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA = FCM_TAGSTAREFA.NRESCOPOSTAREFA
                LEFT JOIN FCM_TAGSCHKTAREFA
                  ON FCM_TAGSTAREFA.NRTAGSTAREFA = FCM_TAGSCHKTAREFA.NRTAGSTAREFA
                LEFT JOIN FCM_TAREFACHK
                  ON FCM_TAREFACHK.NRTAREFACHK = FCM_TAGSCHKTAREFA.NRTAREFACHK
                LEFT JOIN FCM_ATIVIDADECHK
                  ON FCM_ATIVIDADECHK.NRATIVIDADECHK = FCM_TAREFACHK.NRATIVIDADECHK";
        $this->connection->executeStatement($sql);
    }

    public function setEscopo($param)
    {
        $sql = "INSERT INTO FCM_ESCOPOSTAREFA (NRESCOPOSTAREFA, NMESCOPOSTAREFA, IDATIVO, NRORG, DTINCLUSAO, DTULTATU)
              VALUES (:NRESCOPOSTAREFA, :NMESCOPOSTAREFA, 'S', :NRORG, SYSDATE, SYSDATE)";
        $this->connection->executeStatement($sql, $param);
    }
}
