import {
    IDictionary, Metadata, Http, IEventParam,
} from '@zeedhi/core';
import {
    Form, Select, TextInput, LoadingService, Textarea, Text, Modal, ModalService,
    DialogService,
} from '@zeedhi/common';
import {
    TekGrid,
} from '@zeedhi/teknisa-components-common';
import { Utilities } from '@/util/Utilities';
import { Kanban } from '@zeedhi/zd-kanban';

export class Fm00020000SolicitacoesController {
    public visibilidade: boolean = true;

    public NRGLOBAL: string = '';

    public NRCLASSIFY: string = '';

    public PARAMS: string = '';

    private classifyModal!: Modal;

    private cdoper: string = '';

    private nrSolicitacaoAtual: string = '';

    currentRow: any;

    /* -------------------- Tela: /solicitacoesDeTarefas -------------------- */
    get visibilidadeFrame() {
        return !this.visibilidade;
    }

    /* Conrola visibilidade do frame
    public visualizarSolicitacoesDetalhes({ component }: any) {
        this.visibilidade = false;
        this.NRGLOBAL = String(component.name.split('_')[1]);
        this.recarregarTabs();
    }

    public voltarPagina() {
        this.visibilidade = true;
        Metadata.getInstance<Tabs>('tab-solicitacoes').activeTab = 0;
    }

    // Solicita uma nova requisição do datasource da tab Histórico
    /* public carregarHistorico() {
        try {
            if (Metadata.getInstance<Tabs>('tab-solicitacoes').activeTab === 0) {
                this.setFilterHistoric();
                Metadata.getInstance<IterableComponentRender>('requestTypesIterable').datasource.get();
            }
        } catch (error) {
            Utilities.showErrorMessage(error);
        }
    }

    // Carregas as informações ao clicar na tab 'Dados'
    public recarregarTabs() {
        const setOfTabs = Metadata.getInstance<Tabs>('tab-solicitacoes');

        if (setOfTabs.tabs[setOfTabs.activeTab].name === 'tab-solicitacoesDetalhes') {
            this.getRequestInfo();
        }
    }

    /* public setFilterIteravel({ component }: any) {
        let id: any;

        switch (component.name) {
            case 'newRequestsIterable':
                id = '1';
                break;
            case 'requestsIPIterable':
                id = '2';
                break;
            case 'requestsMadeIterable':
                id = '3';

                break;
                case 'CompletedRequestsIterable':
                    id = '4';
                break;
            default:
                break;
        }
        component.datasource.setFilter({
            IDSITUACAO: id,
        });
    } */

    /* public setFilterHistoric() {
        try {
            const tabComponent = Metadata.getInstance<TekIterableComponentRender>('requestTypesIterable');
            tabComponent.datasource.setFilter({
                NRSOLICITACAO: this.NRGLOBAL,
            });
        } catch (error) {
            Utilities.showErrorMessage(error);
        }
    } */

    /* -------------------- Controle botões e cards --------------------*/
    // Muda o label do botão 'Ver descrição' na aba 'Histórico'

    /* public changeDescriptionButton({ component }: { component: Button }) {
        const collapaseCard = component.parent as IDictionary;

        if (component.label === 'Ver Descrição') {
            component.label = 'Fechar Descrição';
            collapaseCard.expanded = true;
        } else {
            component.label = 'Ver Descrição';
            collapaseCard.expanded = false;
        }
    } */

    // Título da página ( Usando assim porque será usada tb no modal)
    // public requestTitle: string = '';

    // public requestDescription: string = '';

    /* Parametros usados para a classificação da solicitação (São usados assim pq tenho o modal sendo aberto por dois locais diferentes)
    public requestParams: IDictionary = {
        requestId: '',
        requestNrOpenedBy: '',
        requestOpenOn: '',
        requestNrLocation: '',
    };

    /* public async getRequestInfo() {
        const id = this.NRGLOBAL;
        await Http.get(`/getRequestInfo?nrsolicitacao=${id}`).then((response: IDictionary) => {
            const database = response.data.dataset.info[0];
            const classifyButton = Metadata.getInstance<Button>('classifyButton');
            this.requestTitle = database.NMSOLICITACAO;
            this.requestDescription = database.DSSOLICITACAO;
            this.requestParams.requestId = database.NRSOLICITACAO;
            Metadata.getInstance<ICardTitle>('requestTitle').title = database.NMSOLICITACAO;
            Metadata.getInstance<Text>('requestOpenOn').text = database.DTSOLICITACAO;
            this.requestParams.requestOpenOn = database.DTSOLICITACAO;
            Metadata.getInstance<Text>('requestStatus').text = database.IDSITUACAO;
            Metadata.getInstance<Text>('requestLocation').text = database.NMLOCALCLIENTE;
            Metadata.getInstance<Text>('requestNrLocation').text = database.NRLOCALCLIENTE;
            this.requestParams.requestNrLocation = database.NRLOCALCLIENTE;
            Metadata.getInstance<Text>('requestType').text = database.NMTIPOSOLICITACAO;
            Metadata.getInstance<Text>('requestPriority').text = database.IDPRIORIDADE;
            Metadata.getInstance<Text>('requestOpenedBy').text = database.NMFUNCABERTURA;
            Metadata.getInstance<Text>('requestNrOpenedBy').text = database.CDOPERABERTURA;
            this.requestParams.requestNrOpenedBy = database.CDOPERABERTURA;
            Metadata.getInstance<Text>('taskResponsible').text = database.NMFUNCRESPONSAVEL;
            Metadata.getInstance<Text>('requestDescription').text = database.DSSOLICITACAO;

            if (database.IDSITUACAO !== 'Pendente') {
                classifyButton.label = 'Classificado';
                classifyButton.disabled = true;
            } else {
                classifyButton.label = 'Classificar Solicitação';
                classifyButton.disabled = false;
            }
        });
    } */

    public setPriority({ component }: { component: Select }) {
        const priority = component.selectValue.IDPRIORIDADEPADR;
        const prioritySelect = Metadata.getInstance<Select>('classifyPriority');

        if (priority === 'Baixa') {
            prioritySelect.setValue('1');
        } else if (priority === 'Média') {
            prioritySelect.setValue('2');
        } else if (priority === 'Alta') {
            prioritySelect.setValue('3');
        } else {
            prioritySelect.setValue('4');
        }
    }

    // Classificar solicitação
    public classificarSolicitacao() {
        if (Metadata.getInstance<Form>('classifyForm').validate()) {
            LoadingService.show();
            Http.post('/classifyRequest', {
                NRSOLICITACAO: Metadata.getInstance<TextInput>('nrsolicitacao').value,
                NRLOCALCLIENTE: Metadata.getInstance<TextInput>('nrlocalcliente').value,
                NMSOLICITACAO: Metadata.getInstance<TextInput>('classifyTitle').value,
                NRTIPOSOLICITACAO: Metadata.getInstance<Select>('classifyType').value,
                IDPRIORIDADE: Metadata.getInstance<Select>('classifyPriority').value,
                CDOPERRESPONSAVEL: Metadata.getInstance<Select>('classifyResponsible').value,
                NRCHECKLIST: Metadata.getInstance<Select>('classifyChecklist').value,
                DSSOLICITACAO: Metadata.getInstance<Textarea>('classifyDescription').value,
            }).then(() => {
                Utilities.showSuccessMessage();
                Metadata.getInstance<Kanban>('kanban').datasource?.get();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                this.closeClassifyModal();
                LoadingService.hide();
            });
        }
    }

    // Busca os tipos de requisição e monta o select
    public getRequestTypes() {
        const selectObject = Metadata.getInstance<Select>('classifyType');
        Http.get('/getRequestTypes').then((response: IDictionary) => {
            response.data.dataset.info.forEach((database: IDictionary) => {
                selectObject.datasource.data.push({
                    value: database.NRTIPOSOLICITACAO,
                    name: database.NMTIPOSOLICITACAO,
                    priority: database.IDPRIORIDADEPADR,
                });
            });
        });
    }

    public visibilidadeBotaoClassificar({ component }: any) {
        if (component.name.split('_')[1] !== '1') {
            component.isVisible = false;
        } else {
            component.isVisible = true;
        }
    }

    public async visibilidadeBotaoEncerrar({ component }: any) {
        if (component.name.split('_')[1] === '3') {
            const operadoresSolicitacao = await this.getOperadoresSolicitacao(component.name.split('_')[0]);
            component.isVisible = operadoresSolicitacao.includes(this.cdoper);
        } else {
            component.isVisible = false;
        }
    }

    public async getOperadoresSolicitacao(nrSolicitacao: any) {
        let operadoresSolicitacao: any[] = [];
        await Http.get('/getRequestHistoric', {
            params: {
                NRSOLICITACAO: nrSolicitacao,
            },
        }).then((response) => {
            operadoresSolicitacao = response.data.data.map((obj: any) => obj.CDOPERULTATU);
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        });

        return operadoresSolicitacao;
    }

    /* eslint-disable */
    public confirmarEncerrarSolicitacao({ component, event }: any) {
        event?.stopPropagation();
        this.nrSolicitacaoAtual = component.name.split('_')[0];
        Utilities.showConfirmDeleteMessage(event, 'Fm00020000SolicitacoesController.encerrarSolicitacao', 'Atenção', 'Deseja realmente deseja encerrar a solicitação selecionada?');
    }
    /* eslint-enable */

    public encerrarSolicitacao() {
        LoadingService.show();
        Http.post('/encerrarSolicitacao', {
            NRSOLICITACAO: this.nrSolicitacaoAtual,
            NMSOLICITACAO: Metadata.getInstance<Text>(`${this.nrSolicitacaoAtual}_text`).text,
            CDOPERSOLICITANTE: Metadata.getInstance<Text>(`${this.nrSolicitacaoAtual}_operador`).text,
        }).then(() => {
            Utilities.showSuccessMessage();
            Metadata.getInstance<Kanban>('kanban').datasource?.get();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            DialogService.hide();
            LoadingService.hide();
        });
    }

    public modalSolicitacao!: Modal;

    public nrsolicitacao: any = '';

    public async criarModais() {
        this.classifyModal = await ModalService.createFromJson('/fm_00020_000_solicitacoes/modal/fm_00020_000_modal_classificar_solicitacoes', true);
        this.modalSolicitacao = await ModalService.createFromJson('/fm_00020_000_solicitacoes/modal/fm_00020_002_visualizar_solicitacao', true);
    }

    public destruirModais() {
        this.modalSolicitacao.destroy();
        this.classifyModal.destroy();
    }

    /* eslint-disable */
    public async openClassifyModal({ component, event }: IEventParam<Modal>) {
        event?.stopPropagation();
        /* eslint-disable */
        this.nrsolicitacao = component.name.split('_')[0];
        this.classifyModal.show();
        setTimeout(() => {
            this.onMountedInformacoesModalClassificar();
        });
    }

    public abrirModalVisualizarSolicitacao({ component, event }: IEventParam<Modal>) {
        event?.stopPropagation();
        this.modalSolicitacao.show();
        this.nrsolicitacao = component.name.split('_')[0];
        setTimeout(() => {
            this.onMountedInformacoesSolicitacao();
        });
    }
    /* eslint-enable */

    public closeClassifyModal() {
        this.classifyModal.hide();
    }

    public fecharModalVisualizarSolicitacao() {
        this.modalSolicitacao.hide();
    }

    public onMountedInformacoesSolicitacao() {
        const kanban = Metadata.getInstance<Kanban>('kanban');
        const dados: any = (kanban.datasource?.data.filter((element: any) => element.NRSOLICITACAO === parseInt(this.nrsolicitacao, 10)));

        Metadata.getInstance<Text>('text-aberto').text = dados[0].DTSOLICITACAO;
        Metadata.getInstance<Text>('text-situacao').text = dados[0].IDSITUACAOTEXT;
        Metadata.getInstance<Text>('text-local').text = `${dados[0].NMLOCALCLIENTE} - ${dados[0].NMLOCALCLIENTEPAI}`;
        Metadata.getInstance<Text>('text-tp-solicitacao').text = dados[0].NMTIPOSOLICITACAO;
        Metadata.getInstance<Text>('text-prioridade').text = dados[0].IDPRIORIDADETEXT;
        Metadata.getInstance<Text>('text-aberto-por').text = dados[0].NMFUNCABERTURA;
        Metadata.getInstance<Text>('text-responsavel').text = dados[0].NMFUNCRESPONSAVEL;
        Metadata.getInstance<Text>('text-descricao').text = dados[0].DSSOLICITACAO;

        Metadata.getInstance<TekGrid>('tek-grid-historico').datasource.setFilter({
            NRSOLICITACAO: dados[0].NRSOLICITACAO,
        });
    }

    public onMountedInformacoesModalClassificar() {
        const kanban = Metadata.getInstance<Kanban>('kanban');
        const dados: any = (kanban.datasource?.data.filter((element: any) => element.NRSOLICITACAO === parseInt(this.nrsolicitacao, 10)));

        Metadata.getInstance<TextInput>('nrsolicitacao').value = dados[0].NRSOLICITACAO;
        Metadata.getInstance<TextInput>('nrlocalcliente').value = dados[0].NRLOCALCLIENTE;
        Metadata.getInstance<TextInput>('nmlocalcliente').value = dados[0].NMLOCALCLIENTE;
        Metadata.getInstance<TextInput>('classifyTitle').value = dados[0].NMSOLICITACAO;
        Metadata.getInstance<Select>('classifyType').value = dados[0].NRTIPOSOLICITACAO;
        Metadata.getInstance<Select>('classifyPriority').value = dados[0].IDPRIORIDADE;
        Metadata.getInstance<Select>('classifyResponsible').value = dados[0].CDOPERRESPONSAVEL;
        Metadata.getInstance<Textarea>('classifyDescription').value = dados[0].DSSOLICITACAO;
    }

    public async setOperadorLogado() {
        this.cdoper = await this.getOperadorLogado();
    }

    public async getOperadorLogado() {
        let cdoper: string = '';
        try {
            const response = await Http.get('/getOperadorLogado');
            cdoper = response.data.CDOPERADOR;
        } catch (error) {
            Utilities.showErrorMessage(error);
        }
        return cdoper;
    }
}
